#include	<stdio.h>
#include	<stdlib.h>
/* LOCAL INCLUDES */
#include	<malloclib.h>
#include	<defs.h>
#include	<types.h>
#include	<lum.h>
#include	<errexit.h>
#include	<pnm.h>


void P_pnm_putus(ushort n, FILE *fp)
{
  if(n >= 10)
    P_pnm_putus(n/10,fp);
  putc(n%10 + '0',fp);
}

int P_pnm_getint(FILE *fp)
{
	register char 	ch;
	register int 	i;

  do {
    ch = P_pnm_getc(fp);
  } while(ch == ' ' || ch == '\t' || ch == '\n' || ch == '\r');

  if(ch < '0' || ch > '9')
    errexit("P_pgm_getint: junk in file where an integer should be\n");
  i = 0;
  do {
    i = i * 10 + ch - '0';
    ch = P_pnm_getc(fp);
  } while (ch >= '0' && ch <= '9');

  return i;
}


char P_pnm_getc(FILE *fp)
{
	register int 	ich;
	register char 	ch;

  ich = getc(fp);
  if(ich == EOF)
    errexit("P_pnm_getc: EOF / read error\n");
  ch = (char)ich;

  if(ch == '#') {
    do {
      ich = getc(fp);
      if (ich == EOF)
        errexit("P_pnm_getc: EOF / read error\n");
        ch = (char)ich;
    } while (ch != '\n' && ch != '\r');
  }

  return ch;
}


byte P_pnm_getrawbyte(FILE *fp)
{
	register int 	iby;

  if((iby = getc(fp))==EOF)
    errexit("P_pnm_getrawbyte: EOF / read error\n");
  return (uchar) iby;
}


bit P_pnm_getbit(FILE *fp)
{
	register char 	ch;

  do {
    ch = P_pnm_getc(fp);
  }
  while(ch == ' ' || ch == '\t' || ch == '\n' || ch == '\r');

  if(ch != '0' && ch != '1')
    errexit("P_pgm_getbit: junk in file where bits should be\n");

  return (ch == '1') ? 1 : 0;
}
