#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<math.h>
#include	"types.h"
#include	"ppm.h"

int main(int argc, char **argv)
{
	int		r,c,format;
	gray		maxval;		/* unsigned char (1 byte) */
	PPMheader	ihp,ohp;
	ulong		*larr;

  P_ppm_make_header(&ihp);
  P_ppm_make_header(&ohp);
  P_ppm_read_header(stdin,ihp);
  P_ppm_copy_header(ihp,ohp);
  P_ppm_write_header(stdout,ohp);

  P_ppm_get_rows(ihp,&r);
  P_ppm_get_cols(ihp,&c);
  P_ppm_get_format(ihp,&format);
  P_ppm_get_maxval(ihp,&maxval);

  if((larr = (ulong *)malloc(r*c*sizeof(ulong)))==NULL) {
    fprintf(stderr,"not enough memory\n");
    exit(1);
  }

  P_ppm_read_larr(stdin,larr,r,c,format,maxval);
  P_ppm_write_larr(stdout,larr,r,c,format,maxval);
}
